% Programa para calibrar una cmara a partir
% de una sola imagen (se estima solo la distancia focal),
% usando un patrn de dos crculos concntricos
% Fraga 28/06/2011

# Las matrices de los dos crculos proyectados

A1 = [ 1.0000e-06  -1.5031e-14  -3.0000e-04;
  -1.5031e-14   6.6631e-06  -1.1775e-03;
  -3.0000e-04  -1.1775e-03   2.3139e-01 ];

A2 = [ 1.0000e-06  -1.5525e-14  -3.0000e-04;
  -1.5525e-14   6.9491e-06  -1.3510e-03;
  -3.0000e-04  -1.3510e-03   3.3668e-01 ];

# Las raices podran calcularse aqu como:
b1 = A2(3,3)/A1(3,3)
b2 = (1/.25) * b1

# Pero generalmente no conocemos las escalas (a)

# Aqui se estn normalizando las dos elipses segn A(3,3)
a = A1(3,3);
A1 = A1 / a;
a = A2(3,3);
A2 = A2 / a;

A1i = A1^(-1);
A2i = A2^(-1);

% e = eig( A1*A2i )
% A1*A2i es igual que B ! Por que?
% B = A1*A2i;
B = A2i*A1;

% B es positiva definida
% B11 = B(1:2,1:2)
% det(B11)
% det(B)

e = eig( B )

%% La raiz repetida
printf("Raiz repetida\n");
[m, k] = min(abs(median(e)-e));
e(k)
C = e(k)*A1i-A2i;
[Eval ev] = eig( C );

for i=1:3
	ev(i,i) = sqrt( ev(i,i) );
end
% Eval(:,1 ) *= -1.0;
J1 = Eval*ev;

%% La raiz nica
printf("Raiz unica\n");
[m, k] = max(abs(median(e)-e));
% e(k)
C = e(k)*A1i-A2i;
[Eval ev] = eig( C );

for i=1:3
	ev(i,i) = sqrt( ev(i,i) );
end
%Eval(:,1 ) *= -1.0;
J = Eval*ev;
J(1,3) = J1(1,1);
J(2,3) = J1(2,1);
J(3,3) = J1(3,1);
J
u0 = 300;
v0 = 200;
fnew = - u0*u0 - v0*v0 + u0*(J(1,2)/J(3,2) + J(1,1)/J(3,1)) + \
                         v0*(J(2,2)/J(3,2) + J(2,1)/J(3,1))  \
       - J(2,1)*J(2,2)/(J(3,1)*J(3,2)) - J(1,1)*J(1,2)/(J(3,1)*J(3,2));

f = sqrt(abs(fnew));

Ki = [ 1/f  0  -u0/f; 
        0  1/f -v0/f;
        0   0    -1]


M = Ki*J
% M(:,1)
k1 = norm( M(:,1) );
% k2 = norm( M(:,1) )
M1 = (1/k1) * M

t = M1(:,3);
R = M1;

%% Correccin para escoger la orientacin correcta:
v = cross ( R(:,1), R(:,2) )
v2 = [ 0 0 1] * v;
if v2 < 0  
    R(:,1) = -R(:,1)
    R( :,3 ) = cross( R( :,1 ), R( :,2 ) );
end

c = R'*t

alfa1 = atan2( R(3,2), -R(3,1) );
alfa = alfa1*180/pi

beta1 = acos( R(3,3) );
beta = beta1*180/pi

gama1 = atan2( R(2,3), R(1,3) );                              
gama = gama1*180/pi                                           
                                                              
% alfa, beta y gama estn ahora en grados.                    
                                                              
% Paso los ngulos a radianes para recalcular R               
alfa = alfa*pi/180;                                           
beta = beta*pi/180;                                           
gama = gama*pi/180;                                           
                                                              
Rz = [ cos(alfa) -sin(alfa)  0;                               
       sin(alfa)  cos(alfa)  0;                               
           0          0      1];                              
                                                              
Ry = [ cos(beta)  0  sin(beta);                               
           0      1      0;                                   
       -sin(beta) 0  cos(beta)];                              
                                                              
Rz2 = [ cos(gama) -sin(gama)  0;                              
       sin(gama)  cos(gama)  0;                               
           0          0      1];                              
                                                              
R = Rz2 * Ry * Rz
